type splitlim_t = Splitlimit of int;;
type cut_t = Cut of bool;;

type prover_t =
  Meson of splitlim_t
| Metis of splitlim_t
| Leancop of cut_t
(*| Prover9
| Hh_recon*)
;;

let run_prover = function
  Meson (Splitlimit sl) ->
    meson_split_limit := sl;
    (* increase the maximum depth from 50 (default) to 1000 *)
    let ASM_MESON_TAC = GEN_MESON_TAC 0 1000 1 in
    let MESON_TAC ths = POP_ASSUM_LIST(K ALL_TAC) THEN ASM_MESON_TAC ths in
    let MESON ths tm = prove(tm,MESON_TAC ths) in
    MESON
| Metis (Splitlimit sl) -> Metis_tactic.split_limit := sl; Metis_tactic.METIS
| Leancop (Cut c) -> Leancop.cut := c; Leancop.LEANCOP
(*| Prover9  -> prover9
| Hh_recon -> hh_recon*)
;;

let string_of_prover = function
  Meson (Splitlimit sl) -> "meson" ^ string_of_int sl
| Metis (Splitlimit sl) -> "metis" ^ string_of_int sl
| Leancop (Cut c) -> "leancop-" ^ if c then "cut" else "nocut"
;;
(*| Prover9  -> "prover9"
| Hh_recon -> "hhrecon"*)

